<html>
<head>
<title>OgreMemoryAllocatorConfig.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreMemoryAllocatorConfig.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreMemoryAllocatorConfig_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef __MemoryAllocatorConfig_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define __MemoryAllocatorConfig_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreMemoryAllocatedObject_8h.html">OgreMemoryAllocatedObject.h</a>&quot;</span> 
<a name="l00033"></a>00033 
<a name="l00114"></a>00114 
<a name="l00119"></a>00119 
<a name="l00124"></a>00124 
<a name="l00127"></a>00127 
<a name="l00130"></a>00130 
<a name="l00140"></a>00140 <span class="keyword">namespace </span>Ogre
<a name="l00141"></a>00141 {
<a name="l00158"></a><a class="code" href="group__Memory.html#ga830fab51be174d6f2849857cb1abb36a">00158</a>     <span class="keyword">enum</span> <a class="code" href="group__Memory.html#ga830fab51be174d6f2849857cb1abb36a" title="A set of categories that indicate the purpose of a chunk of memory being allocated.">MemoryCategory</a>
<a name="l00159"></a>00159     {
<a name="l00161"></a><a class="code" href="group__Memory.html#gga830fab51be174d6f2849857cb1abb36aa8ac29a2852b1b5fe79d1659b16f521cb">00161</a>         <a class="code" href="group__Memory.html#gga830fab51be174d6f2849857cb1abb36aa8ac29a2852b1b5fe79d1659b16f521cb" title="General purpose.">MEMCATEGORY_GENERAL</a> = 0,
<a name="l00163"></a><a class="code" href="group__Memory.html#gga830fab51be174d6f2849857cb1abb36aaf9e04ff475de4493bc942a9c73da4c2e">00163</a>         <a class="code" href="group__Memory.html#gga830fab51be174d6f2849857cb1abb36aaf9e04ff475de4493bc942a9c73da4c2e" title="Geometry held in main memory.">MEMCATEGORY_GEOMETRY</a> = 1, 
<a name="l00165"></a><a class="code" href="group__Memory.html#gga830fab51be174d6f2849857cb1abb36aa24267bedbd1115a8f208e4ee355693e4">00165</a>         <a class="code" href="group__Memory.html#gga830fab51be174d6f2849857cb1abb36aa24267bedbd1115a8f208e4ee355693e4" title="Animation data like tracks, bone matrices.">MEMCATEGORY_ANIMATION</a> = 2, 
<a name="l00167"></a><a class="code" href="group__Memory.html#gga830fab51be174d6f2849857cb1abb36aa8a55fa0fcaa8403bb51ca210f882ed90">00167</a>         <a class="code" href="group__Memory.html#gga830fab51be174d6f2849857cb1abb36aa8a55fa0fcaa8403bb51ca210f882ed90" title="Nodes, control data.">MEMCATEGORY_SCENE_CONTROL</a> = 3,
<a name="l00169"></a><a class="code" href="group__Memory.html#gga830fab51be174d6f2849857cb1abb36aaffe1e3d51d961175f8f2756611439181">00169</a>         <a class="code" href="group__Memory.html#gga830fab51be174d6f2849857cb1abb36aaffe1e3d51d961175f8f2756611439181" title="Scene object instances.">MEMCATEGORY_SCENE_OBJECTS</a> = 4,
<a name="l00171"></a><a class="code" href="group__Memory.html#gga830fab51be174d6f2849857cb1abb36aa04bad2e7f64cc2b6f4cda9f56b59e5b4">00171</a>         <a class="code" href="group__Memory.html#gga830fab51be174d6f2849857cb1abb36aa04bad2e7f64cc2b6f4cda9f56b59e5b4" title="Other resources.">MEMCATEGORY_RESOURCE</a> = 5,
<a name="l00173"></a><a class="code" href="group__Memory.html#gga830fab51be174d6f2849857cb1abb36aaa037d2f843117cd5fb39ec064d7ff23b">00173</a>         <a class="code" href="group__Memory.html#gga830fab51be174d6f2849857cb1abb36aaa037d2f843117cd5fb39ec064d7ff23b" title="Scripting.">MEMCATEGORY_SCRIPTING</a> = 6,
<a name="l00175"></a><a class="code" href="group__Memory.html#gga830fab51be174d6f2849857cb1abb36aa29274489311d683a88676dbb1c779788">00175</a>         <a class="code" href="group__Memory.html#gga830fab51be174d6f2849857cb1abb36aa29274489311d683a88676dbb1c779788" title="Rendersystem structures.">MEMCATEGORY_RENDERSYS</a> = 7,
<a name="l00176"></a>00176 
<a name="l00177"></a>00177         
<a name="l00178"></a>00178         <span class="comment">// sentinel value, do not use </span>
<a name="l00179"></a><a class="code" href="group__Memory.html#gga830fab51be174d6f2849857cb1abb36aa4ff2b9446477e2ea4170b09d8aaa1b67">00179</a>         <a class="code" href="group__Memory.html#gga830fab51be174d6f2849857cb1abb36aa4ff2b9446477e2ea4170b09d8aaa1b67">MEMCATEGORY_COUNT</a> = 8
<a name="l00180"></a>00180     };
<a name="l00184"></a>00184 }
<a name="l00185"></a>00185 
<a name="l00186"></a>00186 <span class="preprocessor">#include &quot;<a class="code" href="OgreMemoryAllocatedObject_8h.html">OgreMemoryAllocatedObject.h</a>&quot;</span>
<a name="l00187"></a>00187 <span class="preprocessor">#include &quot;<a class="code" href="OgreMemorySTLAllocator_8h.html">OgreMemorySTLAllocator.h</a>&quot;</span>
<a name="l00188"></a>00188 
<a name="l00189"></a>00189 <span class="preprocessor">#if OGRE_MEMORY_ALLOCATOR == OGRE_MEMORY_ALLOCATOR_NEDPOOLING</span>
<a name="l00190"></a>00190 <span class="preprocessor"></span>
<a name="l00191"></a>00191 <span class="preprocessor">#  include &quot;<a class="code" href="OgreMemoryNedPooling_8h.html">OgreMemoryNedPooling.h</a>&quot;</span>
<a name="l00192"></a>00192 <span class="keyword">namespace </span>Ogre
<a name="l00193"></a>00193 {
<a name="l00194"></a>00194     <span class="comment">// configure default allocators based on the options above</span>
<a name="l00195"></a>00195     <span class="comment">// notice how we&#39;re not using the memory categories here but still roughing them out</span>
<a name="l00196"></a>00196     <span class="comment">// in your allocators you might choose to create different policies per category</span>
<a name="l00197"></a>00197 
<a name="l00198"></a>00198     <span class="comment">// configurable category, for general malloc</span>
<a name="l00199"></a>00199     <span class="comment">// notice how we ignore the category here, you could specialise</span>
<a name="l00200"></a><a class="code" href="classOgre_1_1CategorisedAllocPolicy.html">00200</a>     <span class="keyword">template</span> &lt;MemoryCategory Cat&gt; <span class="keyword">class </span><a class="code" href="classOgre_1_1CategorisedAllocPolicy.html">CategorisedAllocPolicy</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1NedPoolingPolicy.html" title="An allocation policy for use with AllocatedObject and STLAllocator.">NedPoolingPolicy</a>{};
<a name="l00201"></a><a class="code" href="classOgre_1_1CategorisedAlignAllocPolicy.html">00201</a>     <span class="keyword">template</span> &lt;MemoryCategory Cat, <span class="keywordtype">size_t</span> align = 0&gt; <span class="keyword">class </span><a class="code" href="classOgre_1_1CategorisedAlignAllocPolicy.html">CategorisedAlignAllocPolicy</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1NedPoolingAlignedPolicy.html" title="An allocation policy for use with AllocatedObject and STLAllocator, which aligns memory at a given bo...">NedPoolingAlignedPolicy</a>&lt;align&gt;{};
<a name="l00202"></a>00202 }
<a name="l00203"></a>00203 
<a name="l00204"></a>00204 <span class="preprocessor">#elif OGRE_MEMORY_ALLOCATOR == OGRE_MEMORY_ALLOCATOR_NED</span>
<a name="l00205"></a>00205 <span class="preprocessor"></span>
<a name="l00206"></a>00206 <span class="preprocessor">#  include &quot;<a class="code" href="OgreMemoryNedAlloc_8h.html">OgreMemoryNedAlloc.h</a>&quot;</span>
<a name="l00207"></a>00207 <span class="keyword">namespace </span>Ogre
<a name="l00208"></a>00208 {
<a name="l00209"></a>00209     <span class="comment">// configure default allocators based on the options above</span>
<a name="l00210"></a>00210     <span class="comment">// notice how we&#39;re not using the memory categories here but still roughing them out</span>
<a name="l00211"></a>00211     <span class="comment">// in your allocators you might choose to create different policies per category</span>
<a name="l00212"></a>00212 
<a name="l00213"></a>00213     <span class="comment">// configurable category, for general malloc</span>
<a name="l00214"></a>00214     <span class="comment">// notice how we ignore the category here, you could specialise</span>
<a name="l00215"></a>00215     <span class="keyword">template</span> &lt;MemoryCategory Cat&gt; <span class="keyword">class </span>CategorisedAllocPolicy : <span class="keyword">public</span> NedAllocPolicy{};
<a name="l00216"></a>00216     <span class="keyword">template</span> &lt;MemoryCategory Cat, <span class="keywordtype">size_t</span> align = 0&gt; <span class="keyword">class </span>CategorisedAlignAllocPolicy : <span class="keyword">public</span> NedAlignedAllocPolicy&lt;align&gt;{};
<a name="l00217"></a>00217 }
<a name="l00218"></a>00218 
<a name="l00219"></a>00219 <span class="preprocessor">#elif OGRE_MEMORY_ALLOCATOR == OGRE_MEMORY_ALLOCATOR_STD</span>
<a name="l00220"></a>00220 <span class="preprocessor"></span>
<a name="l00221"></a>00221 <span class="preprocessor">#  include &quot;<a class="code" href="OgreMemoryStdAlloc_8h.html">OgreMemoryStdAlloc.h</a>&quot;</span>
<a name="l00222"></a>00222 <span class="keyword">namespace </span>Ogre
<a name="l00223"></a>00223 {
<a name="l00224"></a>00224     <span class="comment">// configure default allocators based on the options above</span>
<a name="l00225"></a>00225     <span class="comment">// notice how we&#39;re not using the memory categories here but still roughing them out</span>
<a name="l00226"></a>00226     <span class="comment">// in your allocators you might choose to create different policies per category</span>
<a name="l00227"></a>00227 
<a name="l00228"></a>00228     <span class="comment">// configurable category, for general malloc</span>
<a name="l00229"></a>00229     <span class="comment">// notice how we ignore the category here</span>
<a name="l00230"></a>00230     <span class="keyword">template</span> &lt;MemoryCategory Cat&gt; <span class="keyword">class </span>CategorisedAllocPolicy : <span class="keyword">public</span> StdAllocPolicy{};
<a name="l00231"></a>00231     <span class="keyword">template</span> &lt;MemoryCategory Cat, <span class="keywordtype">size_t</span> align = 0&gt; <span class="keyword">class </span>CategorisedAlignAllocPolicy : <span class="keyword">public</span> StdAlignedAllocPolicy&lt;align&gt;{};
<a name="l00232"></a>00232 
<a name="l00233"></a>00233     <span class="comment">// if you wanted to specialise the allocation per category, here&#39;s how it might work:</span>
<a name="l00234"></a>00234     <span class="comment">// template &lt;&gt; class CategorisedAllocPolicy&lt;MEMCATEGORY_SCENE_OBJECTS&gt; : public YourSceneObjectAllocPolicy{};</span>
<a name="l00235"></a>00235     <span class="comment">// template &lt;size_t align&gt; class CategorisedAlignAllocPolicy&lt;MEMCATEGORY_SCENE_OBJECTS, align&gt; : public YourSceneObjectAllocPolicy&lt;align&gt;{};</span>
<a name="l00236"></a>00236     
<a name="l00237"></a>00237     
<a name="l00238"></a>00238 }
<a name="l00239"></a>00239 
<a name="l00240"></a>00240 <span class="preprocessor">#else</span>
<a name="l00241"></a>00241 <span class="preprocessor"></span>    
<a name="l00242"></a>00242 <span class="comment">// your allocators here?</span>
<a name="l00243"></a>00243 
<a name="l00244"></a>00244 <span class="preprocessor">#endif</span>
<a name="l00245"></a>00245 <span class="preprocessor"></span>
<a name="l00246"></a>00246 <span class="keyword">namespace </span>Ogre
<a name="l00247"></a>00247 {
<a name="l00248"></a>00248     <span class="comment">// Useful shortcuts</span>
<a name="l00249"></a><a class="code" href="namespaceOgre.html#ad4ca7bb13f62006a192960fda3b0151e">00249</a>     <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1CategorisedAllocPolicy.html">CategorisedAllocPolicy&lt;Ogre::MEMCATEGORY_GENERAL&gt;</a> <a class="code" href="namespaceOgre.html#ad4ca7bb13f62006a192960fda3b0151e">GeneralAllocPolicy</a>;
<a name="l00250"></a><a class="code" href="namespaceOgre.html#a89e5a164d08384010e03c34574474b4d">00250</a>     <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1CategorisedAllocPolicy.html">CategorisedAllocPolicy&lt;Ogre::MEMCATEGORY_GEOMETRY&gt;</a> <a class="code" href="namespaceOgre.html#a89e5a164d08384010e03c34574474b4d">GeometryAllocPolicy</a>;
<a name="l00251"></a><a class="code" href="namespaceOgre.html#a61c92fc2d65ecf3d3da5078c57f85f2a">00251</a>     <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1CategorisedAllocPolicy.html">CategorisedAllocPolicy&lt;Ogre::MEMCATEGORY_ANIMATION&gt;</a> <a class="code" href="namespaceOgre.html#a61c92fc2d65ecf3d3da5078c57f85f2a">AnimationAllocPolicy</a>;
<a name="l00252"></a><a class="code" href="namespaceOgre.html#a8668cddbec3443fa8e571a3bde593524">00252</a>     <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1CategorisedAllocPolicy.html">CategorisedAllocPolicy&lt;Ogre::MEMCATEGORY_SCENE_CONTROL&gt;</a> <a class="code" href="namespaceOgre.html#a8668cddbec3443fa8e571a3bde593524">SceneCtlAllocPolicy</a>;
<a name="l00253"></a><a class="code" href="namespaceOgre.html#a51f31eabec6808e2ff9c298d67617833">00253</a>     <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1CategorisedAllocPolicy.html">CategorisedAllocPolicy&lt;Ogre::MEMCATEGORY_SCENE_OBJECTS&gt;</a> <a class="code" href="namespaceOgre.html#a51f31eabec6808e2ff9c298d67617833">SceneObjAllocPolicy</a>;
<a name="l00254"></a><a class="code" href="namespaceOgre.html#a12051b505684557920b7caa1e87f17c8">00254</a>     <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1CategorisedAllocPolicy.html">CategorisedAllocPolicy&lt;Ogre::MEMCATEGORY_RESOURCE&gt;</a> <a class="code" href="namespaceOgre.html#a12051b505684557920b7caa1e87f17c8">ResourceAllocPolicy</a>;
<a name="l00255"></a><a class="code" href="namespaceOgre.html#a4d33fa1e6c6f52c506e061269a755289">00255</a>     <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1CategorisedAllocPolicy.html">CategorisedAllocPolicy&lt;Ogre::MEMCATEGORY_SCRIPTING&gt;</a> <a class="code" href="namespaceOgre.html#a4d33fa1e6c6f52c506e061269a755289">ScriptingAllocPolicy</a>;
<a name="l00256"></a><a class="code" href="namespaceOgre.html#a585fa2d21e2525019ad062d76df8b719">00256</a>     <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1CategorisedAllocPolicy.html">CategorisedAllocPolicy&lt;Ogre::MEMCATEGORY_RENDERSYS&gt;</a> <a class="code" href="namespaceOgre.html#a585fa2d21e2525019ad062d76df8b719">RenderSysAllocPolicy</a>;
<a name="l00257"></a>00257 
<a name="l00258"></a>00258     <span class="comment">// Now define all the base classes for each allocation</span>
<a name="l00259"></a><a class="code" href="namespaceOgre.html#ac4ac6f663a23cea1dab0ed10688e45d8">00259</a>     <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">AllocatedObject&lt;GeneralAllocPolicy&gt;</a> <a class="code" href="namespaceOgre.html#ac4ac6f663a23cea1dab0ed10688e45d8">GeneralAllocatedObject</a>;
<a name="l00260"></a><a class="code" href="namespaceOgre.html#a1d51ee2afe2fd7bda6f20180ed1338f6">00260</a>     <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">AllocatedObject&lt;GeometryAllocPolicy&gt;</a> <a class="code" href="namespaceOgre.html#a1d51ee2afe2fd7bda6f20180ed1338f6">GeometryAllocatedObject</a>;
<a name="l00261"></a><a class="code" href="namespaceOgre.html#a220b9754c8853bdb56aa4f6d2a2d2bec">00261</a>     <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">AllocatedObject&lt;AnimationAllocPolicy&gt;</a> <a class="code" href="namespaceOgre.html#a220b9754c8853bdb56aa4f6d2a2d2bec">AnimationAllocatedObject</a>;
<a name="l00262"></a><a class="code" href="namespaceOgre.html#aa225e5e6dcbf1073a8990eafdae4fb1c">00262</a>     <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">AllocatedObject&lt;SceneCtlAllocPolicy&gt;</a> <a class="code" href="namespaceOgre.html#aa225e5e6dcbf1073a8990eafdae4fb1c">SceneCtlAllocatedObject</a>;
<a name="l00263"></a><a class="code" href="namespaceOgre.html#a7af43449266010d92fd985d19d3f6483">00263</a>     <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">AllocatedObject&lt;SceneObjAllocPolicy&gt;</a> <a class="code" href="namespaceOgre.html#a7af43449266010d92fd985d19d3f6483">SceneObjAllocatedObject</a>;
<a name="l00264"></a><a class="code" href="namespaceOgre.html#adb684516ccdc078fcab9afb5aaa3cdb3">00264</a>     <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">AllocatedObject&lt;ResourceAllocPolicy&gt;</a> <a class="code" href="namespaceOgre.html#adb684516ccdc078fcab9afb5aaa3cdb3">ResourceAllocatedObject</a>;
<a name="l00265"></a><a class="code" href="namespaceOgre.html#a231968a1c453b90df9ab78080c4505da">00265</a>     <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">AllocatedObject&lt;ScriptingAllocPolicy&gt;</a> <a class="code" href="namespaceOgre.html#a231968a1c453b90df9ab78080c4505da">ScriptingAllocatedObject</a>;
<a name="l00266"></a><a class="code" href="namespaceOgre.html#a58ac0addbec4db9072a7405d75e6bd57">00266</a>     <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">AllocatedObject&lt;RenderSysAllocPolicy&gt;</a> <a class="code" href="namespaceOgre.html#a58ac0addbec4db9072a7405d75e6bd57">RenderSysAllocatedObject</a>;
<a name="l00267"></a>00267 
<a name="l00268"></a>00268 
<a name="l00269"></a>00269     <span class="comment">// Per-class allocators defined here</span>
<a name="l00270"></a>00270     <span class="comment">// NOTE: small, non-virtual classes should not subclass an allocator</span>
<a name="l00271"></a>00271     <span class="comment">// the virtual function table could double their size and make them less efficient</span>
<a name="l00272"></a>00272     <span class="comment">// use primitive or STL allocators / deallocators for those</span>
<a name="l00273"></a><a class="code" href="namespaceOgre.html#ae50d0e41173a3de1eba795db887fc4c0">00273</a>     <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">ScriptingAllocatedObject</a>    <a class="code" href="namespaceOgre.html#ae50d0e41173a3de1eba795db887fc4c0">AbstractNodeAlloc</a>;
<a name="l00274"></a><a class="code" href="namespaceOgre.html#ae09578a5f721385da35583d80a40ff8f">00274</a>     <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">AnimationAllocatedObject</a>    <a class="code" href="namespaceOgre.html#ae09578a5f721385da35583d80a40ff8f">AnimableAlloc</a>;
<a name="l00275"></a><a class="code" href="namespaceOgre.html#a45280f006598c2e3c01e1fa1eb1c0aeb">00275</a>     <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">AnimationAllocatedObject</a>    <a class="code" href="namespaceOgre.html#a45280f006598c2e3c01e1fa1eb1c0aeb">AnimationAlloc</a>;
<a name="l00276"></a><a class="code" href="namespaceOgre.html#a3a7148114d38cef237dc8bf95cb91cd3">00276</a>     <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">GeneralAllocatedObject</a>      <a class="code" href="namespaceOgre.html#a3a7148114d38cef237dc8bf95cb91cd3">ArchiveAlloc</a>;
<a name="l00277"></a><a class="code" href="namespaceOgre.html#a8688596fd4772e25d4d24b91bd26fc3c">00277</a>     <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">GeometryAllocatedObject</a>     <a class="code" href="namespaceOgre.html#a8688596fd4772e25d4d24b91bd26fc3c">BatchedGeometryAlloc</a>;
<a name="l00278"></a><a class="code" href="namespaceOgre.html#a4d5903ed39d36fb554acb8a14c4e941b">00278</a>     <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">RenderSysAllocatedObject</a>    <a class="code" href="namespaceOgre.html#a4d5903ed39d36fb554acb8a14c4e941b">BufferAlloc</a>;
<a name="l00279"></a><a class="code" href="namespaceOgre.html#a62bd950b43a50257f8aa1589d2e823f9">00279</a>     <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">GeneralAllocatedObject</a>      <a class="code" href="namespaceOgre.html#a62bd950b43a50257f8aa1589d2e823f9">CodecAlloc</a>;
<a name="l00280"></a><a class="code" href="namespaceOgre.html#a5d60f07603a9106ef3ea80c2436071e3">00280</a>     <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">ResourceAllocatedObject</a>     <a class="code" href="namespaceOgre.html#a5d60f07603a9106ef3ea80c2436071e3">CompositorInstAlloc</a>;
<a name="l00281"></a><a class="code" href="namespaceOgre.html#a36fae75ecb951f16758e8f867e537318">00281</a>     <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">GeneralAllocatedObject</a>      <a class="code" href="namespaceOgre.html#a36fae75ecb951f16758e8f867e537318">ConfigAlloc</a>;
<a name="l00282"></a><a class="code" href="namespaceOgre.html#ac34508fbac0e38aa4bb253ccf0708c56">00282</a>     <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">GeneralAllocatedObject</a>      <a class="code" href="namespaceOgre.html#ac34508fbac0e38aa4bb253ccf0708c56">ControllerAlloc</a>;
<a name="l00283"></a><a class="code" href="namespaceOgre.html#a6cb7d42eba87cebf8ccb40505b63377a">00283</a>     <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">GeometryAllocatedObject</a>     <a class="code" href="namespaceOgre.html#a6cb7d42eba87cebf8ccb40505b63377a">DebugGeomAlloc</a>;
<a name="l00284"></a><a class="code" href="namespaceOgre.html#a0a4a723194700acb950b79d7192c7639">00284</a>     <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">GeneralAllocatedObject</a>      <a class="code" href="namespaceOgre.html#a0a4a723194700acb950b79d7192c7639">DynLibAlloc</a>;
<a name="l00285"></a><a class="code" href="namespaceOgre.html#a47d4cfd39390ea7f0bde7edff0a6423b">00285</a>     <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">GeometryAllocatedObject</a>     <a class="code" href="namespaceOgre.html#a47d4cfd39390ea7f0bde7edff0a6423b">EdgeDataAlloc</a>;
<a name="l00286"></a><a class="code" href="namespaceOgre.html#afab320e0856ce249ec1e1a4d404981ec">00286</a>     <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">GeneralAllocatedObject</a>      <a class="code" href="namespaceOgre.html#afab320e0856ce249ec1e1a4d404981ec">FactoryAlloc</a>;
<a name="l00287"></a><a class="code" href="namespaceOgre.html#ac42757f609ae0b4aba4815a0e8084caa">00287</a>     <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">SceneObjAllocatedObject</a>     <a class="code" href="namespaceOgre.html#ac42757f609ae0b4aba4815a0e8084caa">FXAlloc</a>;
<a name="l00288"></a><a class="code" href="namespaceOgre.html#a1e40a7870ebd749e8cc8da346af3a3c8">00288</a>     <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">GeneralAllocatedObject</a>      <a class="code" href="namespaceOgre.html#a1e40a7870ebd749e8cc8da346af3a3c8">ImageAlloc</a>;
<a name="l00289"></a><a class="code" href="namespaceOgre.html#a2b83ab3362f4516b51f2a0238e8ac7c5">00289</a>     <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">GeometryAllocatedObject</a>     <a class="code" href="namespaceOgre.html#a2b83ab3362f4516b51f2a0238e8ac7c5">IndexDataAlloc</a>;
<a name="l00290"></a><a class="code" href="namespaceOgre.html#ad43ae31cfa3f0521786631f5ffe4c18a">00290</a>     <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">GeneralAllocatedObject</a>      <a class="code" href="namespaceOgre.html#ad43ae31cfa3f0521786631f5ffe4c18a">LogAlloc</a>;
<a name="l00291"></a><a class="code" href="namespaceOgre.html#a7f9d4a08ffbda0738cebc31b60faae03">00291</a>     <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">SceneObjAllocatedObject</a>     <a class="code" href="namespaceOgre.html#a7f9d4a08ffbda0738cebc31b60faae03">MovableAlloc</a>;
<a name="l00292"></a><a class="code" href="namespaceOgre.html#ab81544a3d3f08a24fff526b288c4d5ba">00292</a>     <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">SceneCtlAllocatedObject</a>     <a class="code" href="namespaceOgre.html#ab81544a3d3f08a24fff526b288c4d5ba">NodeAlloc</a>;
<a name="l00293"></a><a class="code" href="namespaceOgre.html#afec5829b83af2dee85d271b16c5ab609">00293</a>     <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">SceneObjAllocatedObject</a>     <a class="code" href="namespaceOgre.html#afec5829b83af2dee85d271b16c5ab609">OverlayAlloc</a>;
<a name="l00294"></a><a class="code" href="namespaceOgre.html#a9cd4601f9bf87a6bd2846370ccea6acb">00294</a>     <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">RenderSysAllocatedObject</a>    <a class="code" href="namespaceOgre.html#a9cd4601f9bf87a6bd2846370ccea6acb">GpuParamsAlloc</a>;
<a name="l00295"></a><a class="code" href="namespaceOgre.html#ae356a34e71ec1870afef50230739c7dc">00295</a>     <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">ResourceAllocatedObject</a>     <a class="code" href="namespaceOgre.html#ae356a34e71ec1870afef50230739c7dc">PassAlloc</a>;
<a name="l00296"></a><a class="code" href="namespaceOgre.html#af63fccb4061ef6ab1a2b9b3085e3c92f">00296</a>     <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">GeometryAllocatedObject</a>     <a class="code" href="namespaceOgre.html#af63fccb4061ef6ab1a2b9b3085e3c92f">PatchAlloc</a>;
<a name="l00297"></a><a class="code" href="namespaceOgre.html#abf9224e43c0858fdb5828c8dbbd58b05">00297</a>     <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">GeneralAllocatedObject</a>      <a class="code" href="namespaceOgre.html#abf9224e43c0858fdb5828c8dbbd58b05">PluginAlloc</a>;
<a name="l00298"></a><a class="code" href="namespaceOgre.html#a250dfc29da6341127d7d386e06101e67">00298</a>     <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">GeneralAllocatedObject</a>      <a class="code" href="namespaceOgre.html#a250dfc29da6341127d7d386e06101e67">ProfilerAlloc</a>;
<a name="l00299"></a><a class="code" href="namespaceOgre.html#a48699950804f68c746cbefabf20a3fa7">00299</a>     <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">GeometryAllocatedObject</a>     <a class="code" href="namespaceOgre.html#a48699950804f68c746cbefabf20a3fa7">ProgMeshAlloc</a>;
<a name="l00300"></a><a class="code" href="namespaceOgre.html#ab5b177f3272759202a585928bcd3906f">00300</a>     <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">SceneCtlAllocatedObject</a>     <a class="code" href="namespaceOgre.html#ab5b177f3272759202a585928bcd3906f">RenderQueueAlloc</a>;
<a name="l00301"></a><a class="code" href="namespaceOgre.html#a1154f3f32829ce6787b6ac69569bf89b">00301</a>     <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">RenderSysAllocatedObject</a>    <a class="code" href="namespaceOgre.html#a1154f3f32829ce6787b6ac69569bf89b">RenderSysAlloc</a>;
<a name="l00302"></a><a class="code" href="namespaceOgre.html#aaa653fbb322c81fdf7c29d8a621c0bfb">00302</a>     <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">GeneralAllocatedObject</a>      <a class="code" href="namespaceOgre.html#aaa653fbb322c81fdf7c29d8a621c0bfb">RootAlloc</a>;
<a name="l00303"></a><a class="code" href="namespaceOgre.html#a26f1823e78b0275e485bc519e4199480">00303</a>     <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">ResourceAllocatedObject</a>     <a class="code" href="namespaceOgre.html#a26f1823e78b0275e485bc519e4199480">ResourceAlloc</a>;
<a name="l00304"></a><a class="code" href="namespaceOgre.html#ab314a0c39a23a8ca15d867db9dd0f204">00304</a>     <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">GeneralAllocatedObject</a>      <a class="code" href="namespaceOgre.html#ab314a0c39a23a8ca15d867db9dd0f204">SerializerAlloc</a>;
<a name="l00305"></a><a class="code" href="namespaceOgre.html#ab5dc8e76f824d92c77fc11edd09f900b">00305</a>     <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">SceneCtlAllocatedObject</a>     <a class="code" href="namespaceOgre.html#ab5dc8e76f824d92c77fc11edd09f900b">SceneMgtAlloc</a>;
<a name="l00306"></a><a class="code" href="namespaceOgre.html#a290b9222311de853679ae9efa942e713">00306</a>     <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">ScriptingAllocatedObject</a>    <a class="code" href="namespaceOgre.html#a290b9222311de853679ae9efa942e713">ScriptCompilerAlloc</a>;
<a name="l00307"></a><a class="code" href="namespaceOgre.html#a5553b2ac4d5a74c0dc16b4851418ebe6">00307</a>     <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">ScriptingAllocatedObject</a>    <a class="code" href="namespaceOgre.html#a5553b2ac4d5a74c0dc16b4851418ebe6">ScriptTranslatorAlloc</a>;
<a name="l00308"></a><a class="code" href="namespaceOgre.html#a060a8fd0d2f2acb1e8da2820e60ecd0b">00308</a>     <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">SceneCtlAllocatedObject</a>     <a class="code" href="namespaceOgre.html#a060a8fd0d2f2acb1e8da2820e60ecd0b">ShadowDataAlloc</a>;
<a name="l00309"></a><a class="code" href="namespaceOgre.html#ab1b4c43359603ea0d0cace50d6fc57ee">00309</a>     <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">GeneralAllocatedObject</a>      <a class="code" href="namespaceOgre.html#ab1b4c43359603ea0d0cace50d6fc57ee">StreamAlloc</a>;
<a name="l00310"></a><a class="code" href="namespaceOgre.html#a11c9152a33c78bdc13a9cfdc41833d35">00310</a>     <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">SceneObjAllocatedObject</a>     <a class="code" href="namespaceOgre.html#a11c9152a33c78bdc13a9cfdc41833d35">SubEntityAlloc</a>;
<a name="l00311"></a><a class="code" href="namespaceOgre.html#a28c456e4a7bcbaf9afa7da4b59c3d18e">00311</a>     <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">ResourceAllocatedObject</a>     <a class="code" href="namespaceOgre.html#a28c456e4a7bcbaf9afa7da4b59c3d18e">SubMeshAlloc</a>;
<a name="l00312"></a><a class="code" href="namespaceOgre.html#a14ad07d89fe48693b5abe86054702dbb">00312</a>     <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">ResourceAllocatedObject</a>     <a class="code" href="namespaceOgre.html#a14ad07d89fe48693b5abe86054702dbb">TechniqueAlloc</a>;
<a name="l00313"></a><a class="code" href="namespaceOgre.html#a2facde8318daf273780d84304f60cfa0">00313</a>     <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">GeneralAllocatedObject</a>      <a class="code" href="namespaceOgre.html#a2facde8318daf273780d84304f60cfa0">TimerAlloc</a>;
<a name="l00314"></a><a class="code" href="namespaceOgre.html#a2286e700a22b9e109cbf2aa95f9ce094">00314</a>     <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">ResourceAllocatedObject</a>     <a class="code" href="namespaceOgre.html#a2286e700a22b9e109cbf2aa95f9ce094">TextureUnitStateAlloc</a>;
<a name="l00315"></a><a class="code" href="namespaceOgre.html#af1b4f61252337a39768b2e8963551198">00315</a>     <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">GeneralAllocatedObject</a>      <a class="code" href="namespaceOgre.html#af1b4f61252337a39768b2e8963551198">UtilityAlloc</a>;
<a name="l00316"></a><a class="code" href="namespaceOgre.html#ab030dab0a47bd28ac42be0260af08719">00316</a>     <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">GeometryAllocatedObject</a>     <a class="code" href="namespaceOgre.html#ab030dab0a47bd28ac42be0260af08719">VertexDataAlloc</a>;
<a name="l00317"></a><a class="code" href="namespaceOgre.html#a3d3ba82ee4ce61a447259f7c8a19cb2a">00317</a>     <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">RenderSysAllocatedObject</a>    <a class="code" href="namespaceOgre.html#a3d3ba82ee4ce61a447259f7c8a19cb2a">ViewportAlloc</a>;
<a name="l00318"></a><a class="code" href="namespaceOgre.html#a5fae23475351938803d15fcbabc3b6d8">00318</a>     <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">SceneCtlAllocatedObject</a>     <a class="code" href="namespaceOgre.html#a5fae23475351938803d15fcbabc3b6d8">LodAlloc</a>;
<a name="l00319"></a>00319 
<a name="l00320"></a>00320     <span class="comment">// Containers (by-value only)</span>
<a name="l00321"></a>00321     <span class="comment">// Will  be of the form:</span>
<a name="l00322"></a>00322     <span class="comment">// typedef STLAllocator&lt;T, DefaultAllocPolicy, Category&gt; TAlloc;</span>
<a name="l00323"></a>00323     <span class="comment">// for use in vector&lt;T, TAlloc&gt;::type </span>
<a name="l00324"></a>00324     
<a name="l00325"></a>00325 
<a name="l00326"></a>00326 
<a name="l00327"></a>00327 }
<a name="l00328"></a>00328 
<a name="l00329"></a>00329 <span class="comment">// Util functions</span>
<a name="l00330"></a>00330 <span class="keyword">namespace </span>Ogre
<a name="l00331"></a>00331 {
<a name="l00343"></a>00343     <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00344"></a><a class="code" href="group__Memory.html#gae542663b49eb68a74336d84e11ba0b9c">00344</a>     T* <a class="code" href="group__Memory.html#gae542663b49eb68a74336d84e11ba0b9c" title="Utility function for constructing an array of objects with placement new, without using new[] (which ...">constructN</a>(T* basePtr, <span class="keywordtype">size_t</span> count)
<a name="l00345"></a>00345     {
<a name="l00346"></a>00346         <span class="keywordflow">for</span> (<span class="keywordtype">size_t</span> i = 0; i &lt; count; ++i)
<a name="l00347"></a>00347         {
<a name="l00348"></a>00348             <span class="keyword">new</span> ((<span class="keywordtype">void</span>*)(basePtr+i)) T();
<a name="l00349"></a>00349         }
<a name="l00350"></a>00350         <span class="keywordflow">return</span> basePtr;
<a name="l00351"></a>00351     }
<a name="l00355"></a>00355 }
<a name="l00356"></a>00356 <span class="comment">// define macros </span>
<a name="l00357"></a>00357 
<a name="l00365"></a>00365 <span class="preprocessor">#if OGRE_DEBUG_MODE</span>
<a name="l00366"></a>00366 <span class="preprocessor"></span>
<a name="l00368"></a>00368 <span class="preprocessor">#   define OGRE_MALLOC(bytes, category) ::Ogre::CategorisedAllocPolicy&lt;category&gt;::allocateBytes(bytes, __FILE__, __LINE__, __FUNCTION__)</span>
<a name="l00369"></a>00369 <span class="preprocessor"></span>
<a name="l00370"></a>00370 <span class="preprocessor">#   define OGRE_ALLOC_T(T, count, category) static_cast&lt;T*&gt;(::Ogre::CategorisedAllocPolicy&lt;category&gt;::allocateBytes(sizeof(T)*(count), __FILE__, __LINE__, __FUNCTION__))</span>
<a name="l00371"></a>00371 <span class="preprocessor"></span>
<a name="l00372"></a>00372 <span class="preprocessor">#   define OGRE_FREE(ptr, category) ::Ogre::CategorisedAllocPolicy&lt;category&gt;::deallocateBytes((void*)ptr)</span>
<a name="l00373"></a>00373 <span class="preprocessor"></span>
<a name="l00375"></a>00375 <span class="preprocessor">#   define OGRE_NEW_T(T, category) new (::Ogre::CategorisedAllocPolicy&lt;category&gt;::allocateBytes(sizeof(T), __FILE__, __LINE__, __FUNCTION__)) T</span>
<a name="l00376"></a>00376 <span class="preprocessor"></span>
<a name="l00377"></a>00377 <span class="preprocessor">#   define OGRE_NEW_ARRAY_T(T, count, category) ::Ogre::constructN(static_cast&lt;T*&gt;(::Ogre::CategorisedAllocPolicy&lt;category&gt;::allocateBytes(sizeof(T)*(count), __FILE__, __LINE__, __FUNCTION__)), count) </span>
<a name="l00378"></a>00378 <span class="preprocessor"></span>
<a name="l00379"></a>00379 <span class="preprocessor">#   define OGRE_DELETE_T(ptr, T, category) if(ptr){(ptr)-&gt;~T(); ::Ogre::CategorisedAllocPolicy&lt;category&gt;::deallocateBytes((void*)ptr);}</span>
<a name="l00380"></a>00380 <span class="preprocessor"></span>
<a name="l00381"></a>00381 <span class="preprocessor">#   define OGRE_DELETE_ARRAY_T(ptr, T, count, category) if(ptr){for (size_t b = 0; b &lt; count; ++b) { (ptr)[b].~T();} ::Ogre::CategorisedAllocPolicy&lt;category&gt;::deallocateBytes((void*)ptr);}</span>
<a name="l00382"></a>00382 <span class="preprocessor"></span>
<a name="l00383"></a>00383 <span class="comment">// aligned allocation</span>
<a name="l00385"></a>00385 <span class="comment"></span><span class="preprocessor">#   define OGRE_MALLOC_SIMD(bytes, category) ::Ogre::CategorisedAlignAllocPolicy&lt;category&gt;::allocateBytes(bytes, __FILE__, __LINE__, __FUNCTION__)</span>
<a name="l00386"></a>00386 <span class="preprocessor"></span>
<a name="l00387"></a>00387 <span class="preprocessor">#   define OGRE_MALLOC_ALIGN(bytes, category, align) ::Ogre::CategorisedAlignAllocPolicy&lt;category, align&gt;::allocateBytes(bytes, __FILE__, __LINE__, __FUNCTION__)</span>
<a name="l00388"></a>00388 <span class="preprocessor"></span>
<a name="l00389"></a>00389 <span class="preprocessor">#   define OGRE_ALLOC_T_SIMD(T, count, category) static_cast&lt;T*&gt;(::Ogre::CategorisedAlignAllocPolicy&lt;category&gt;::allocateBytes(sizeof(T)*(count), __FILE__, __LINE__, __FUNCTION__))</span>
<a name="l00390"></a>00390 <span class="preprocessor"></span>
<a name="l00391"></a>00391 <span class="preprocessor">#   define OGRE_ALLOC_T_ALIGN(T, count, category, align) static_cast&lt;T*&gt;(::Ogre::CategorisedAlignAllocPolicy&lt;category, align&gt;::allocateBytes(sizeof(T)*(count), __FILE__, __LINE__, __FUNCTION__))</span>
<a name="l00392"></a>00392 <span class="preprocessor"></span>
<a name="l00393"></a>00393 <span class="preprocessor">#   define OGRE_FREE_SIMD(ptr, category) ::Ogre::CategorisedAlignAllocPolicy&lt;category&gt;::deallocateBytes(ptr)</span>
<a name="l00394"></a>00394 <span class="preprocessor"></span>
<a name="l00395"></a>00395 <span class="preprocessor">#   define OGRE_FREE_ALIGN(ptr, category, align) ::Ogre::CategorisedAlignAllocPolicy&lt;category, align&gt;::deallocateBytes(ptr)</span>
<a name="l00396"></a>00396 <span class="preprocessor"></span>
<a name="l00398"></a>00398 <span class="preprocessor">#   define OGRE_NEW_T_SIMD(T, category) new (::Ogre::CategorisedAlignAllocPolicy&lt;category&gt;::allocateBytes(sizeof(T), __FILE__, __LINE__, __FUNCTION__)) T</span>
<a name="l00399"></a>00399 <span class="preprocessor"></span>
<a name="l00400"></a>00400 <span class="preprocessor">#   define OGRE_NEW_ARRAY_T_SIMD(T, count, category) ::Ogre::constructN(static_cast&lt;T*&gt;(::Ogre::CategorisedAlignAllocPolicy&lt;category&gt;::allocateBytes(sizeof(T)*(count), __FILE__, __LINE__, __FUNCTION__)), count) </span>
<a name="l00401"></a>00401 <span class="preprocessor"></span>
<a name="l00402"></a>00402 <span class="preprocessor">#   define OGRE_DELETE_T_SIMD(ptr, T, category) if(ptr){(ptr)-&gt;~T(); ::Ogre::CategorisedAlignAllocPolicy&lt;category&gt;::deallocateBytes(ptr);}</span>
<a name="l00403"></a>00403 <span class="preprocessor"></span>
<a name="l00404"></a>00404 <span class="preprocessor">#   define OGRE_DELETE_ARRAY_T_SIMD(ptr, T, count, category) if(ptr){for (size_t b = 0; b &lt; count; ++b) { (ptr)[b].~T();} ::Ogre::CategorisedAlignAllocPolicy&lt;category&gt;::deallocateBytes(ptr);}</span>
<a name="l00405"></a>00405 <span class="preprocessor"></span>
<a name="l00406"></a>00406 <span class="preprocessor">#   define OGRE_NEW_T_ALIGN(T, category, align) new (::Ogre::CategorisedAlignAllocPolicy&lt;category, align&gt;::allocateBytes(sizeof(T), __FILE__, __LINE__, __FUNCTION__)) T</span>
<a name="l00407"></a>00407 <span class="preprocessor"></span>
<a name="l00408"></a>00408 <span class="preprocessor">#   define OGRE_NEW_ARRAY_T_ALIGN(T, count, category, align) ::Ogre::constructN(static_cast&lt;T*&gt;(::Ogre::CategorisedAlignAllocPolicy&lt;category, align&gt;::allocateBytes(sizeof(T)*(count), __FILE__, __LINE__, __FUNCTION__)), count) </span>
<a name="l00409"></a>00409 <span class="preprocessor"></span>
<a name="l00410"></a>00410 <span class="preprocessor">#   define OGRE_DELETE_T_ALIGN(ptr, T, category, align) if(ptr){(ptr)-&gt;~T(); ::Ogre::CategorisedAlignAllocPolicy&lt;category, align&gt;::deallocateBytes(ptr);}</span>
<a name="l00411"></a>00411 <span class="preprocessor"></span>
<a name="l00412"></a>00412 <span class="preprocessor">#   define OGRE_DELETE_ARRAY_T_ALIGN(ptr, T, count, category, align) if(ptr){for (size_t _b = 0; _b &lt; count; ++_b) { (ptr)[_b].~T();} ::Ogre::CategorisedAlignAllocPolicy&lt;category, align&gt;::deallocateBytes(ptr);}</span>
<a name="l00413"></a>00413 <span class="preprocessor"></span>
<a name="l00414"></a>00414 <span class="comment">// new / delete for classes deriving from AllocatedObject (alignment determined by per-class policy)</span>
<a name="l00415"></a>00415 <span class="comment">// Also hooks up the file/line/function params</span>
<a name="l00416"></a>00416 <span class="comment">// Can only be used with classes that derive from AllocatedObject since customised new/delete needed</span>
<a name="l00417"></a>00417 <span class="preprocessor">#   define OGRE_NEW new (__FILE__, __LINE__, __FUNCTION__)</span>
<a name="l00418"></a>00418 <span class="preprocessor"></span><span class="preprocessor">#   define OGRE_DELETE delete</span>
<a name="l00419"></a>00419 <span class="preprocessor"></span>
<a name="l00420"></a>00420 
<a name="l00421"></a>00421 <span class="preprocessor">#else // !OGRE_DEBUG_MODE</span>
<a name="l00422"></a>00422 <span class="preprocessor"></span>
<a name="l00424"></a><a class="code" href="group__Memory.html#ga2382b731c3d757f74f0fedf2b14ed9d6">00424</a> <span class="preprocessor">#   define OGRE_MALLOC(bytes, category) ::Ogre::CategorisedAllocPolicy&lt;category&gt;::allocateBytes(bytes)</span>
<a name="l00425"></a>00425 <span class="preprocessor"></span>
<a name="l00426"></a><a class="code" href="group__Memory.html#ga3211e4a6a806aa789b38dce2432ef472">00426</a> <span class="preprocessor">#   define OGRE_ALLOC_T(T, count, category) static_cast&lt;T*&gt;(::Ogre::CategorisedAllocPolicy&lt;category&gt;::allocateBytes(sizeof(T)*(count)))</span>
<a name="l00427"></a>00427 <span class="preprocessor"></span>
<a name="l00428"></a><a class="code" href="group__Memory.html#gacfd8dc937cf390c7bff05495f0dc10cf">00428</a> <span class="preprocessor">#   define OGRE_FREE(ptr, category) ::Ogre::CategorisedAllocPolicy&lt;category&gt;::deallocateBytes((void*)ptr)</span>
<a name="l00429"></a>00429 <span class="preprocessor"></span>
<a name="l00431"></a><a class="code" href="group__Memory.html#ga46253f12658ce0922e982a8a9dd11312">00431</a> <span class="preprocessor">#   define OGRE_NEW_T(T, category) new (::Ogre::CategorisedAllocPolicy&lt;category&gt;::allocateBytes(sizeof(T))) T</span>
<a name="l00432"></a>00432 <span class="preprocessor"></span>
<a name="l00433"></a><a class="code" href="group__Memory.html#ga6c428bbdad197df6a4ba22d3c1d48f5a">00433</a> <span class="preprocessor">#   define OGRE_NEW_ARRAY_T(T, count, category) ::Ogre::constructN(static_cast&lt;T*&gt;(::Ogre::CategorisedAllocPolicy&lt;category&gt;::allocateBytes(sizeof(T)*(count))), count) </span>
<a name="l00434"></a>00434 <span class="preprocessor"></span>
<a name="l00435"></a><a class="code" href="group__Memory.html#ga0b0974da65362dd8a14071e7f6e4daca">00435</a> <span class="preprocessor">#   define OGRE_DELETE_T(ptr, T, category) if(ptr){(ptr)-&gt;~T(); ::Ogre::CategorisedAllocPolicy&lt;category&gt;::deallocateBytes((void*)ptr);}</span>
<a name="l00436"></a>00436 <span class="preprocessor"></span>
<a name="l00437"></a><a class="code" href="group__Memory.html#gab9f9fa14d424036dc5881cbcb3c741e0">00437</a> <span class="preprocessor">#   define OGRE_DELETE_ARRAY_T(ptr, T, count, category) if(ptr){for (size_t b = 0; b &lt; count; ++b) { (ptr)[b].~T();} ::Ogre::CategorisedAllocPolicy&lt;category&gt;::deallocateBytes((void*)ptr);}</span>
<a name="l00438"></a>00438 <span class="preprocessor"></span>
<a name="l00439"></a>00439 <span class="comment">// aligned allocation</span>
<a name="l00441"></a><a class="code" href="group__Memory.html#gafd7ddaef10ac9ea1ffbd18902167b9a2">00441</a> <span class="comment"></span><span class="preprocessor">#   define OGRE_MALLOC_SIMD(bytes, category) ::Ogre::CategorisedAlignAllocPolicy&lt;category&gt;::allocateBytes(bytes)</span>
<a name="l00442"></a>00442 <span class="preprocessor"></span>
<a name="l00443"></a><a class="code" href="group__Memory.html#ga876cf0a4c7e209ce798b5e6708ca2343">00443</a> <span class="preprocessor">#   define OGRE_MALLOC_ALIGN(bytes, category, align) ::Ogre::CategorisedAlignAllocPolicy&lt;category, align&gt;::allocateBytes(bytes)</span>
<a name="l00444"></a>00444 <span class="preprocessor"></span>
<a name="l00445"></a><a class="code" href="group__Memory.html#ga728b719dd1425d46a78fe87d6f9ea6a5">00445</a> <span class="preprocessor">#   define OGRE_ALLOC_T_SIMD(T, count, category) static_cast&lt;T*&gt;(::Ogre::CategorisedAlignAllocPolicy&lt;category&gt;::allocateBytes(sizeof(T)*(count)))</span>
<a name="l00446"></a>00446 <span class="preprocessor"></span>
<a name="l00447"></a><a class="code" href="group__Memory.html#gafc79c14937612b02ac50631c08666b26">00447</a> <span class="preprocessor">#   define OGRE_ALLOC_T_ALIGN(T, count, category, align) static_cast&lt;T*&gt;(::Ogre::CategorisedAlignAllocPolicy&lt;category, align&gt;::allocateBytes(sizeof(T)*(count)))</span>
<a name="l00448"></a>00448 <span class="preprocessor"></span>
<a name="l00449"></a><a class="code" href="group__Memory.html#gaf7501eb098fc6671420c628dc80af2a8">00449</a> <span class="preprocessor">#   define OGRE_FREE_SIMD(ptr, category) ::Ogre::CategorisedAlignAllocPolicy&lt;category&gt;::deallocateBytes((void*)ptr)</span>
<a name="l00450"></a>00450 <span class="preprocessor"></span>
<a name="l00451"></a><a class="code" href="group__Memory.html#gaa06d37a211e3da357b8457ccdb4decac">00451</a> <span class="preprocessor">#   define OGRE_FREE_ALIGN(ptr, category, align) ::Ogre::CategorisedAlignAllocPolicy&lt;category, align&gt;::deallocateBytes((void*)ptr)</span>
<a name="l00452"></a>00452 <span class="preprocessor"></span>
<a name="l00454"></a><a class="code" href="group__Memory.html#ga2f7eef98b7fe3ba9f36630b787d603b1">00454</a> <span class="preprocessor">#   define OGRE_NEW_T_SIMD(T, category) new (::Ogre::CategorisedAlignAllocPolicy&lt;category&gt;::allocateBytes(sizeof(T))) T</span>
<a name="l00455"></a>00455 <span class="preprocessor"></span>
<a name="l00456"></a><a class="code" href="group__Memory.html#gaa55846bae98cf66fd5158ad0d4d623bb">00456</a> <span class="preprocessor">#   define OGRE_NEW_ARRAY_T_SIMD(T, count, category) ::Ogre::constructN(static_cast&lt;T*&gt;(::Ogre::CategorisedAlignAllocPolicy&lt;category&gt;::allocateBytes(sizeof(T)*(count))), count) </span>
<a name="l00457"></a>00457 <span class="preprocessor"></span>
<a name="l00458"></a><a class="code" href="group__Memory.html#ga1a5d598e538371f2fca9608277051347">00458</a> <span class="preprocessor">#   define OGRE_DELETE_T_SIMD(ptr, T, category) if(ptr){(ptr)-&gt;~T(); ::Ogre::CategorisedAlignAllocPolicy&lt;category&gt;::deallocateBytes((void*)ptr);}</span>
<a name="l00459"></a>00459 <span class="preprocessor"></span>
<a name="l00460"></a><a class="code" href="group__Memory.html#ga3ceedc1e74432821ffab664232c12d04">00460</a> <span class="preprocessor">#   define OGRE_DELETE_ARRAY_T_SIMD(ptr, T, count, category) if(ptr){for (size_t b = 0; b &lt; count; ++b) { (ptr)[b].~T();} ::Ogre::CategorisedAlignAllocPolicy&lt;category&gt;::deallocateBytes((void*)ptr);}</span>
<a name="l00461"></a>00461 <span class="preprocessor"></span>
<a name="l00462"></a><a class="code" href="group__Memory.html#ga4c928813aac2c96ae5cc775aacd3e26d">00462</a> <span class="preprocessor">#   define OGRE_NEW_T_ALIGN(T, category, align) new (::Ogre::CategorisedAlignAllocPolicy&lt;category, align&gt;::allocateBytes(sizeof(T))) T</span>
<a name="l00463"></a>00463 <span class="preprocessor"></span>
<a name="l00464"></a><a class="code" href="group__Memory.html#ga51224b5c8af6fd85e192975ebe20139b">00464</a> <span class="preprocessor">#   define OGRE_NEW_ARRAY_T_ALIGN(T, count, category, align) ::Ogre::constructN(static_cast&lt;T*&gt;(::Ogre::CategorisedAlignAllocPolicy&lt;category, align&gt;::allocateBytes(sizeof(T)*(count))), count) </span>
<a name="l00465"></a>00465 <span class="preprocessor"></span>
<a name="l00466"></a><a class="code" href="group__Memory.html#ga076af127ea8efe2284e03ab4c2057603">00466</a> <span class="preprocessor">#   define OGRE_DELETE_T_ALIGN(ptr, T, category, align) if(ptr){(ptr)-&gt;~T(); ::Ogre::CategorisedAlignAllocPolicy&lt;category, align&gt;::deallocateBytes((void*)ptr);}</span>
<a name="l00467"></a>00467 <span class="preprocessor"></span>
<a name="l00468"></a><a class="code" href="group__Memory.html#ga25e1e9ce907fc367cc735465c940da23">00468</a> <span class="preprocessor">#   define OGRE_DELETE_ARRAY_T_ALIGN(ptr, T, count, category, align) if(ptr){for (size_t _b = 0; _b &lt; count; ++_b) { (ptr)[_b].~T();} ::Ogre::CategorisedAlignAllocPolicy&lt;category, align&gt;::deallocateBytes((void*)ptr);}</span>
<a name="l00469"></a>00469 <span class="preprocessor"></span>
<a name="l00470"></a>00470 <span class="comment">// new / delete for classes deriving from AllocatedObject (alignment determined by per-class policy)</span>
<a name="l00471"></a><a class="code" href="group__Memory.html#gab5fc1358fd5a889de0a06d07e45df1ff">00471</a> <span class="preprocessor">#   define OGRE_NEW new </span>
<a name="l00472"></a><a class="code" href="group__Memory.html#gad18eff671a00617b21c8e35a7f545690">00472</a> <span class="preprocessor"></span><span class="preprocessor">#   define OGRE_DELETE delete</span>
<a name="l00473"></a>00473 <span class="preprocessor"></span>
<a name="l00474"></a>00474 <span class="preprocessor">#endif // OGRE_DEBUG_MODE</span>
<a name="l00475"></a>00475 <span class="preprocessor"></span>
<a name="l00476"></a>00476 
<a name="l00477"></a>00477 <span class="keyword">namespace </span>Ogre
<a name="l00478"></a>00478 {
<a name="l00483"></a>00483     <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00484"></a><a class="code" href="namespaceOgre.html#af78076f7c0517bfdac61219333d3ff8e">00484</a>     <span class="keywordtype">void</span> <a class="code" href="namespaceOgre.html#af78076f7c0517bfdac61219333d3ff8e" title="Function which invokes OGRE_DELETE on a given pointer.">deletePtr</a>(T* ptr)
<a name="l00485"></a>00485     {
<a name="l00486"></a>00486         <a class="code" href="group__Memory.html#gad18eff671a00617b21c8e35a7f545690">OGRE_DELETE</a> ptr;
<a name="l00487"></a>00487     }
<a name="l00488"></a>00488 }
<a name="l00489"></a>00489 
<a name="l00493"></a>00493 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:50
</p>
</body>
</html>
